import * as mc from "@minecraft/server";

mc.world.beforeEvents.worldInitialize.subscribe(event => {
	const itemComponentRegistry = event.itemComponentRegistry;
	const blockComponentRegistry = event.blockComponentRegistry;

	itemComponentRegistry.registerCustomComponent("ale:morcego",{onUse: arg => {morcego(arg.source);}});
	blockComponentRegistry.registerCustomComponent("al3:block_summon_vampire",{onPlayerDestroy: arg => {block_summon_vampire(arg.block);}});
});

mc.system.afterEvents.scriptEventReceive.subscribe(event => {
    const ale = event.id.split("ale:")[1];
    const eventEntity = event.sourceEntity;
    switch (ale) {
      case "fly":
        eventEntity.applyKnockback(eventEntity.getViewDirection().x,eventEntity.getViewDirection().z,0.15,0);
      break
      case "fly2":
        eventEntity.applyKnockback(eventEntity.getViewDirection().x,eventEntity.getViewDirection().z,0.1,0);
      break
  }
});


async function morcego(player) {
  player.runCommandAsync("playanimation @s animation.morcego ale");
  player.runCommandAsync("playsound summon @a ~~~ 1.5");
  morcego2(player, "ale:projetil_tamedmor", [-3, 0, 0], "mor1");
  morcego2(player, "ale:projetil_tamedmor", [3, 0, 0], "mor2");
  morcego2(player, "ale:projetil_tamedmor", [0, 0, -3], "mor3");
  morcego2(player, "ale:projetil_tamedmor", [0, 0, 3], "mor4");
}

function morcego2(player, powerId, offset, eventId) {
  const location = offsetL(player.getHeadLocation(),player.getRotation(),offset);
  common(location);
  function common(location) {
    const power = player.dimension.spawnEntity(powerId,location);
    if(eventId != null){
      power.triggerEvent(eventId);
    }
    const projectileComp = power.getComponent("projectile");
    projectileComp.owner = player;
    //projectileComp.shoot(player.getViewDirection());
  }
}

export function offsetL(location,rotation,offset){
  function round100000(number) {
      return Math.round(100000*number)/100000;
  }
  const x_entityRotationY = (rotation.y + 90) * (Math.PI/180);
  const x_positionX = -round100000(Math.sin(x_entityRotationY));
  const x_positionZ = round100000(Math.cos(x_entityRotationY));
  
  const z_entityRotationY = rotation.y * (Math.PI/180);
  const z_entityRotationX = rotation.x * (Math.PI/180);
  const z_positionX = -round100000(Math.sin(z_entityRotationY)*Math.cos(z_entityRotationX));
  const z_positionZ = round100000(Math.cos(z_entityRotationY)*Math.cos(z_entityRotationX));
  const z_positionY = -round100000(Math.sin(z_entityRotationX));
  
  const y_entityRotationY = rotation.y * (Math.PI/180);
  const y_entityRotationX = rotation.x * (Math.PI/180);
  const y_positionX = -round100000(Math.sin(y_entityRotationY)*Math.sin(y_entityRotationX));
  const y_positionZ = round100000(Math.cos(y_entityRotationY)*Math.sin(y_entityRotationX));
  const y_positionY = round100000(Math.cos(y_entityRotationX));

  return {
      x:location.x + x_positionX*offset[0] + y_positionX*offset[1] + z_positionX*offset[2],
      y:location.y + z_positionY*offset[2] + y_positionY*offset[1],
      z:location.z + x_positionZ*offset[0] + y_positionZ*offset[1] + z_positionZ*offset[2]
  }
}

export function block_summon_vampire(block) {
  const dimension = block.dimension;
  const blockLoc = block.location;
  const x = blockLoc.x;
  const y = blockLoc.y;
  const z = blockLoc.z;
  dimension.runCommandAsync(`execute positioned ${x} ${y} ${z} run summon ale:vampire ~~~ ~~`);
}

